﻿using System;

namespace ConsoleApp1
{
    class Log
    {
        private static Log instancja = null; //jedyna instancja

        public static Log Instancja
        {
            get
            {
                if (instancja == null) instancja = new Log();
                return instancja;
            }
        }

        private Log()
        {

        }

        public void Rejestruj(string komunikat)
        {
            Console.WriteLine("Log: " + komunikat);
        }
    }

    class KlasaA
    {
        private Log log = Log.Instancja;

        public void Metoda1()
        {
            log.Rejestruj("KlasaA.Metoda1");
        }
    }

    class KlasaB
    {
        private Log log = Log.Instancja;
        KlasaA obiektA;

        public KlasaB()
        {
            this.obiektA = new KlasaA();
        }

        public void Metoda1()
        {
            log.Rejestruj("KlasaB.Metoda1");
        }

        public void Metoda2()
        {
            log.Rejestruj("KlasaB.Metoda2");
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            KlasaA obiektA = new KlasaA();
            obiektA.Metoda1();
            KlasaB obiektB = new KlasaB();
            obiektB.Metoda1();
            obiektB.Metoda2();
        }

    }
}
